function LSE() {
    var Request = require("sdk/request").Request;
    const {Cu} = require("chrome");
    const {XMLHttpRequest} = require("sdk/net/xhr");
    var notifications = require("sdk/notifications");
    var self = require("sdk/self");
    var tabs = require("sdk/tabs");
    var data = "X";
    this.notify = function (text, url) {
        notifications.notify({
            title: "LinkSnappy",
            text: text,
            data: data,
            iconURL: self.data.url("images/icon128.png"),
            onClick: function () {
                if (url) {
                    tabs.open({
                        url: url
                        //inNewWindow: true
                    });
                }
            }
        });
    };
    this.openurl = function (url) {
        tabs.open({
            url: url,
            inBackground: true
        });
    };
    this.compver = function (installed, required) {
        var a = installed.split('.');
        var b = required.split('.');

        for (var i = 0; i < a.length; ++i) {
            a[i] = Number(a[i]);
        }
        for (var i = 0; i < b.length; ++i) {
            b[i] = Number(b[i]);
        }
        if (a.length == 2) {
            a[2] = 0;
        }

        if (a[0] > b[0]) return true;
        if (a[0] < b[0]) return false;

        if (a[1] > b[1]) return true;
        if (a[1] < b[1]) return false;

        if (a[2] > b[2]) return true;
        if (a[2] < b[2]) return false;

        return true;
    };
    this.findStr = function (str, start, end) {
        var startPoint = str.indexOf(start) + start.length;
        var endPoint = str.indexOf(end);
        if (Number.isInteger(startPoint) && Number.isInteger(endPoint)) {
            str = str.substr(startPoint);
            endPoint = str.indexOf(end);
            str = str.substr(0, endPoint);
            return str;
        } else {
            return false;
        }
    };

    this.checkVersion = function () {
        var currentVersion = self.version;
        var notify = this.notify;
        var compVersion = this.compver;
        Request({
            url: 'https://www.linksnappy.com/upload/plugin-version.txt',
            onComplete: function (response) {
                var serverVersion = response.text;
                if (compVersion(currentVersion, serverVersion) == false) {
                    notify("New version [" + serverVersion + "] of LSE plugin available. Please install it.", "http://www.linksnappy.com/upload/linksnappy_firefox_addon.xpi");
                }
            }
        }).get();
    };
    this.browseTorrents = function (link, dash) {
        var notify = this.notify;
        var findStr = this.findStr;
        Request({
            url: 'https://linksnappy.com' + link,
            onComplete: function (response) {
                this.torrentBrowse = function (fStr) {
                    var str = findStr(fStr, "<tbody>", "</tbody>");
                    var tInfo = str.split("</tr>");
                    var browseList = findStr(fStr, '<i class="fa fa-desktop"></i> ', '</a> </div>');
                    var mParent = browseList.split("</a>");
                    var parent = "";
                    if (mParent.length > 1) {
                        parent = findStr(mParent[mParent.length - 2], 'href="', '"');
                    } else {
                        parent = false;
                    }
                    if (parent == "/myaccount/torrents") {
                        var sp = link.split("/");
                        parent = parent + "/files/" + sp[sp.length - 2];
                    }
                    dash.port.emit("setTorrentBack", parent);
                    var foundAny = false;
                    for (var i = 0; i < (tInfo.length - 1); i++) {
                        var isFolder = 0;
                        var fid = findStr(tInfo[i], '<tr id="', '"');
                        var tName = findStr(tInfo[i], '<td data-sort-value="', '"');
                        var tLink = findStr(tInfo[i], '<a href="', '"');

                        if (tInfo[i].indexOf('<sub>(folder)</sub>') != -1) {
                            isFolder = 1;
                        }
                        var tSize = findStr(tInfo[i], '</a></td>', '</td>') + "<";
                        tSize = findStr(tSize, '>', "<");
                        if (isFolder == 1) {
                            tSize = "";
                        }

                        var mInfo = {
                            id: fid,
                            parent: parent,
                            name: tName,
                            size: tSize,
                            link: tLink,
                            isFolder: isFolder
                        };
                        dash.port.emit("torrentBrowse", mInfo);
                        foundAny = true;
                    }
                    if(!foundAny){
                        dash.port.emit("hideLoader");
                        notify("No files found in this folder");
                    }
                };
                var str = response.text;
                if (response.text.indexOf("fa-sign-out") == -1) {
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-user-secret", event: "click"});
                    //notify("Please Login", false);
                } else {
                    this.torrentBrowse(str);
                }
            }
        }).get();
    };
    this.findTorrents = function (dash) {
        var notify = this.notify;
        var findStr = this.findStr;
        Request({
            url: 'https://linksnappy.com/myaccount/torrents',
            onComplete: function (response) {

                this.torrentInfo = function (fStr) {
                    var usage = findStr(fStr, '<strong>Usage:</strong> ', ' </p>');
                    dash.port.emit("torrentUsage", usage);
                    var str = findStr(fStr, "<tbody>", "</tbody>");
                    //var torrentInfo = {};
                    var tInfo = str.split("</tr>");
                    var foundAny = false;
                    for (var i = 0; i < (tInfo.length - 1); i++) {
                        var downloading = 0;
                        var tID = findStr(tInfo[i], '<tr id="', '"');
                        var tName = findStr(tInfo[i], '<td class="name" data-sort-value="', '"');
                        var tStatus = findStr(tInfo[i], '<td class="status">', '</td>');
                        var tTime = findStr(tInfo[i], '<td data-sort-value="', '"');
                        var tSts = "";
                        if (tStatus.indexOf("startDownload") != -1) {
                            tSts = "start";
                        } else if (tStatus.indexOf("MakeZip") != -1) {
                            tSts = "zip";
                        } else {
                            tSts = tStatus;
                        }

                        if (tInfo[i].indexOf('class="updater"') != -1) {
                            downloading = 1;
                        }

                        var tSize = findStr(tInfo[i], '<td class="size" ', '/td>');
                        tSize = findStr(tSize, ">", "<");
                        dash.port.emit("torrentFiles", {
                            id: tID,
                            name: tName,
                            status: tSts,
                            size: tSize,
                            time: tTime,
                            downloading: downloading
                        });
                        foundAny = true;
                    }
                    if(!foundAny){
                        dash.port.emit("torrentTxtShow");
                        dash.port.emit("hideLoader");
                    }
                };
                var str = response.text;
                if (response.text.indexOf("fa-sign-out") == -1) {
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-user-secret", event: "click"});
                    //notify("Please Login",false);
                }else {
                    this.torrentInfo(str);
                }


            }
        }).get();
    };
    this.torrentZip = function (tid, dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/torrents/GENZIP?torrentid=' + tid,
            onComplete: function (response) {
                console.dir(tid, response.text);
                var data = JSON.parse(response.text);
                if (data.status == "OK") {
                    dash.port.emit("zipStatus", {id: tid, link: data.return});
                } else {
                    notify(data.error, "");
                }
            }
        }).get();

    };
    this.torrentStatus = function (tid, dash) {
        Request({
            url: 'https://linksnappy.com/includes/torrentStatus.php?status=true&tid=' + tid,
            onComplete: function (response) {
                console.dir(tid, response.text);
                var data = JSON.parse(response.text);
                dash.port.emit("torrentStatus", {
                    id: tid,
                    parcent: data.percentDone,
                    status: data.status,
                    downloadRate: data.downloadRate
                });
            }
        }).get();
    };
    this.torrentStart = function (tid, dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/torrents/START?tid=' + tid,
            onComplete: function (response) {
                console.dir(tid, response.text);
                var data = JSON.parse(response.text);
                if (data.status != "ERROR") {
                    dash.port.emit("torrentStart", tid);
                } else {
                    notify("[" + tid + "] " + data.error, false);
                    dash.port.emit("returnStartBtn", tid);
                }
            }
        }).get();
    };
    this.torrentDelete = function (tid, dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/torrents/DELETETORRENT?tid=' + tid,
            onComplete: function (response) {
                console.dir(tid, response.text);
                var data = JSON.parse(response.text);
                if (data.status = "OK") {
                    dash.port.emit("removeEle", "#" + tid);
                } else {
                    notify("Failed to delete torrent[" + tid + "]", false);
                }
            }
        }).get();
    };
    this.filehostStats = function (dash) {
        Request({
            url: 'https://linksnappy.com/api/FILEHOSTS',
            onComplete: function (response) {
                //console.dir(response.text);
                var data = JSON.parse(response.text);
                if (data.status = "OK") {
                    console.dir(data.return);
                    dash.port.emit("filehostStatus", data.return);
                }
            }
        }).get();
    };
    this.formData = function () {
        const {Cc, Ci} = require("chrome");
        return Cc["@mozilla.org/files/formdata;1"].createInstance(Ci.nsIDOMFormData);
    };

    this.torrentUpload = function (file, dash) {
        var fileIO = require("sdk/io/file");
        var notify = this.notify;
        Cu.importGlobalProperties(["File"]);
        var req = new XMLHttpRequest();
        req.open("POST", "https://linksnappy.com/includes/ajaxupload.php");
        req.onload = function () {
            var torrentName = fileIO.basename(file);
//Object.keys(response)[0]
            var response = JSON.parse(req.responseText);
            if (response[torrentName].status != 0) {
                dash.port.emit("triggerEvent", {div: ".menuItem .fa-magnet", event: "click"});
                notify(torrentName + " Added to your torrent queue", false);
            } else {
                notify("Error:" + response[torrentName].error, false);
            }


        };
        var formData = this.formData();
        formData.append("torrentFile", "yes");
        formData.append("torrents[]", new File(file));

        req.send(formData);
    };

    this.torrentMagnet = function (magnet, dash, lsepref) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/torrents/ADDMAGNET?magnetlinks=' + encodeURIComponent(magnet),
            onComplete: function (response) {
                console.log(response.text);
                var magnetResponse = JSON.parse(response.text);
                if (magnetResponse.status == "OK") {
                    //[{"name":"","status":"OK","torrentStatus":"In queue for processing"}]}
                    console.dir(magnetResponse);
                    notify(magnetResponse.return[0].name + " Magnet added successfully", "");
                    if (!dash.isShowing && lsepref["displaypanel"] == 1) {
                        dash.show();
                    }
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-magnet", event: "click"});
                } else {
                    notify(magnetResponse.error, "");
                }

            }
        }).get();
    };
    this.accountInfo = function (dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/USERDETAILS',
            onComplete: function (response) {
                var data = JSON.parse(response.text);
                if (data.status == "OK") {
                    console.dir(data.return);
                    dash.port.emit("getAccount", data.return);
                } else {
                    dash.port.emit("showLogin");
                }
            }
        }).get();
    };
    this.twoFactor = function (reqcode, twofpin, dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/api/VALIDATEPIN?id=' + reqcode + '&twofactorpin=' + twofpin,
            onComplete: function (response) {
                var data = JSON.parse(response.text);
                if (data.status == "OK") {
                    notify("Two factor pin is accepted, Please re-login");
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-user-secret", event: "click"});
                } else {
                    dash.port.emit("hideLoader");
                    notify(data.error, "");
                }
            }
        }).get();
    };
    this.logout = function (dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/logout',
            onComplete: function (response) {
                dash.port.emit("showLogin");
                //dash.port.emit("triggerEvent",{div: ".menuItem .fa-user-secret",event: "click"});
            }
        }).get();
    };
    this.register = function (email, dash) {
        var notify = this.notify;
        Request({
            url: 'https://linksnappy.com/includes/ajaxreg.php?email=' + encodeURIComponent(email),
            onComplete: function (response) {
                var account = JSON.parse(response.text);
                if (account.status == "OK") {
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-user-secret", event: "click"});
                } else {
                    dash.port.emit("hideLoader");
                    dash.port.emit("showLogin");
                    notify(account.error);
                }
            }
        }).get();
    };
    this.login = function (user, pass, dash) {
        var notify = this.notify;
        var accDetails = this.accountInfo;
        Request({
            url: 'https://linksnappy.com/api/AUTHENTICATE?username=' + encodeURIComponent(user) + '&password=' + encodeURIComponent(pass),
            onComplete: function (response) {
                console.log("lselog: ", response.text);
                if (response.text.indexOf("CloudFlare Ray ID") != -1) {
                    dash.port.emit("showLogin");
                    notify("Please open LinkSnappy in Browser", "https://linksnappy.com/");
                }
                var account = JSON.parse(response.text);
                if (account.status == "OK") {
                    console.log("Login Success!");
                    //accDetails(dash);
                    dash.port.emit("triggerEvent", {div: ".menuItem .fa-user-secret", event: "click"});
                }
                else if (account.status == "CAPTCHA") {
                    dash.port.emit("showLogin");
                    notify("You have to enter Captcha to login", "https://linksnappy.com/");
                }

                else if (account.status == "ERROR") {
                    if (account.error.indexOf("Two-Factor Verification Required") != -1) {
                        notify(account.error, "");
                        dash.port.emit("twofactor", account.redirect);
                    } else {
                        dash.port.emit("showLogin");
                        notify(account.error, "");
                    }
                }
                else {
                    notify("Login Error", "");
                }
            }
        }).get();
    };

    this.linkgen = function (info, myFunc, dash, startnow) {
        var open = this.openurl;
        var notify = this.notify;
        var link = info.link;
        var postData = "genLinks={\"link\" : \"" + encodeURIComponent(link) + "\"}";
        Request({
            url: "https://linksnappy.com/api/linkgen",
            content: postData,
            onComplete: function (response) {
                var download = JSON.parse(response.text);
                //console.dir(download);
                //
                if (download.error == "Invalid Username") {
                    notify("Please login to generate link", "https://linksnappy.com");
                    return true;
                }
                if (download.links[0].status == "OK") {
                    var linkInfo = {
                        link: link,
                        downloadlink: download.links[0].generated,
                        filename: decodeURIComponent(download.links[0].filename),
                        status: "generated",
                        id: parseInt(info.id)
                    };
                    if (info.regen) {
                        linkInfo.regen = info.regen;
                    }
                    myFunc(linkInfo);
                    if (startnow) {
                        open(linkInfo.downloadlink);
                    }
                } else {
                    if (info.regen) {
                        dash.port.emit("delfailed",parseInt(info.id))
                        notify(link + "\n" + download.links[0].error,link);
                    }else{
                        dash.port.emit("linkstatus", {id: info.id, error: download.links[0].error});
                    }
                    if (!dash.isShowing) {
                        dash.show();
                    }
                }

            }
        }).post();
    };

    this.checkLink = function (link) {
        var myreg = this.getRegex();
        var reg = new RegExp(myreg, "g");
        var matched = link.match(reg);
        console.log("Regex Match: '" + matched + "'");
        return matched;
    };
    this.getRegex = function (force) {
        var lmlstore = require("sdk/simple-storage");
        var currentDate = new Date();
        var today = currentDate.getDate();
        if (lmlstore.storage.regex && (lmlstore.storage.date && lmlstore.storage.date == today) && !force) {
            console.log("lselog: Using Regex from cache");
            return lmlstore.storage.regex;
        } else {
            Request({
                url: "https://linksnappy.com/api/REGEX",
                onComplete: function (response) {
                    console.log("Downloading Latest Regex");

                    var mytext = response.text;

                    if (/http/.test(mytext)) {
                        lmlstore.storage.date = today;
                        lmlstore.storage.regex = response.text;
                        return lmlstore.storage.regex;
                    } else {
                        return false;
                    }


                }
            }).get();
        }
        console.log("lselog: Using Pre-Stored Regex");
        return '((http|https):\/\/(\w+\.)?rapidshare\.com\/share\/[0-9A-Z]+|files\/[0-9]+\/[0-9a-zA-Z\.-_]+|\#\!download\|[0-9a-z]+\|[0-9]+\|[0-9a-zA-Z\.-_]+|(http|https):\/\/(\w+\.)?(depositfiles\.com|depositfiles\.org|dfiles\.eu|dfiles\.ru)\/([a-z\\/]+)?files\/([a-z0-9]+)\/?(.*)?([^( |"|>|<|\r\n\|\n|$)]+)?|http:\/\/(\w+\.)?crocko\.com\/[A-Z0-9]+\/?(.*)?(\.html)?|(https|http):\/\/(\w+\.)?bigfile\.to\/file\/[0-9a-zA-Z]+\/?(.*)[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?filefactory\.com\/(file|stream)\/[0-9a-zA-Z]+\/?[a-z0-9]?\/?[^( |"|>|<|\r\n\|\n|$)]+|(http|https):\/\/(\w+\.)?netload\.in\/[0-9a-zA-Z]+\/?(.*)?\.htm|(http|https):\/\/(\w+\.)?megashares\.com\/(index\.php\?d01\=|\?d01\=|dl\/)[a-zA-Z0-9]+|http:\/\/(\w+\.)?filesmonster\.com\/download.php\?id=[a-zA-Z0-9\-\_]+|http:\/\/(\w+\.)?uploading\.com(\/)(files)?\/?[a-zA-Z0-9]+\/?(.*)?\/?|http:\/\/(\w+\.)?2shared\.com\/[a-z]+\/[a-zA-Z0-9-_]+\/?(.*)?\.?(html|htm)?|http:\/\/(\w+\.)?4shared\.com\/([a-z0-9]+)\/[a-zA-Z0-9-_]+\/?(.*)?\.?(html|htm|htmht)?|http:\/\/(\w+\.)?(filepost\.com|fp\.io)\/(files\/)?([a-zA-Z0-9]+)|http:\/\/(\w+\.)?extabit\.com\/file\/[a-zA-Z0-9]+\/?(.*)?\/?|http:\/\/(\w+\.)?(keep2share|k2s|keep2s)\.cc\/file\/[a-zA-Z0-9]+\/?(.*)?\/?([^( |"|>|<|\r\n\|\n|$)]+)?|http:\/\/(\w+\.)?gigapeta\.com\/dl\/[a-z0-9]+\/?([^( |"|>|<|\r\n\|\n|$)]+)?|http:\/\/(\w+\.)?fboom\.me\/file\/[a-zA-Z0-9]+\/?(.*)?\/?|http:\/\/(\w+\.)?filecloud\.io\/[0-9a-z]+\/?[0-9]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?ufile\.eu\/[0-9a-z]+|http:\/\/(\w+\.)?lafiles\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?filer\.net\/get\/[0-9a-z]+|http:\/\/(\w+\.)?jumbofiles\.com\/[0-9a-z]+|http:\/\/(\w+\.)?fileswap\.com\/dl\/[0-9a-zA-Z]+\/?(.*)?(\.html)?|(http|https):\/\/(\w+\.)?terafile\.co\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?hipfile\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?cloudsix\.me\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?alfafile\.net\/file\/[a-zA-Z0-9]+\/?(.*)?([^( |"|>|<|\r\n\|\n|$)]+)?|https:\/\/(\w+\.)?depfile\.com\/[0-9a-zA-Z]+|http:\/\/(\w+\.)?sharebeast\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?usefile\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?easybytez\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?uploadrocket\.net\/[0-9a-z]+\/?(.*)?(\.html|htm)?|http:\/\/(\w+\.)?filevelocity\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?redload\.net\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?xerver\.co\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?kingfiles\.net\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?hugefiles\.net\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?prefiles\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?gboxes\.com\/[0-9a-z]+\/?|(http|https):\/\/(\w+\.)?filejoker\.net\/[0-9a-z]+\/?(.*)?|http:\/\/(\w+\.)?tusfiles\.net\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?secureupload\.eu\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?novafile\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?filehaste\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?fileom\.com\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?uptobox\.com\/[0-9a-z]+\/?(.*)?(\.html)?|(http|https):\/\/(\w+\.)?rapidu\.net\/[0-9]+\/?(.*)?|http:\/\/(\w+\.)?upstore\.net\/[0-9a-zA-Z]+\/?(.*)?|http:\/\/(\w+\.)?filehost\.ws\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?hitfile\.net\/[0-9a-zA-Z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?luckyshare\.net\/[0-9]+\/?(.*)?[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?share-online\.biz\/dl\/[0-9A-Z]+|http:\/\/(\w+\.)?mediafire\.com\/(view\/\?|download\/|file\/|(download\.php)?\?)[0-9a-zA-Z]+|http:\/\/(\w+\.)?fileserve\.com\/file\/[0-9A-Za-z]+\/?[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?bitshare\.com\/(\?f\=[0-9a-z]+|files\/[0-9a-z]+\/(.*)(\.html)?)|http:\/\/(\w+\.)?(rapidgator\.net|rg\.to)\/file\/[0-9a-z]+\/?(.*)?(\.html)?|http:\/\/(\w+\.)?(ulozto\.net|uloz\.to|ulozto\.sk|zachowajto\.pl|pornfile\.cz)\/[0-9a-zA-Z]+\/(.*)[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?bayfiles\.net\/file\/[0-9a-zA-Z]+\/[0-9a-zA-Z]+\/(.*)(\.html)?|http:\/\/(\w+\.)?freakshare\.[a-z]{3}\/files\/[0-9a-z]+\/(.*)(\.html)?|http:\/\/(\w+\.)?shareflare\.net\/download\/[0-9a-z\.]+\/(.*)\.html|http:\/\/(\w+\.)?vip-file\.com\/download|downloadlib\/[0-9a-z-\.\-]+\/(.*)\.html|http:\/\/(\w+\.)?letitbit\.net\/download\/[0-9a-z\.]+\/(.*)\.html|http:\/\/(\w+\.)?turbobit\.net\/(download\/free\/)?([0-9a-z]+)\/?(.*)?(\.html)?|http:\/\/(\w+\.)?ugotfile.com\/file\/[0-9]+\/[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?firedrive.com\/file\/[0-9A-Z]+|http:\/\/(\w+\.)?sockshare.com\/file\/[0-9A-Z]+|(http|https):\/\/(\w+\.)?sendspace.com\/file\/[0-9a-z]+|http:\/\/(\w+\.)?datafile.com\/d\/[0-9a-zA-Z]+|(http|https):\/\/(\w+\.)?nitroflare.com\/view\/[0-9A-Z]+\/?([^( |"|>|<|\r\n\|\n|$)]+)?|http:\/\/(\w+\.)?slingfile.com\/file\/[0-9a-zA-Z]+|(http|https):\/\/([0-9a-zA-Z\.]+)?1fichier.com\/?\??([0-9a-zA-Z]+)?|(http|https):\/\/www\.oboom.com\/([A-Z0-9]+)\/?(.*)?[^( |"|>|<|\r\n\|\n|$)]+|http:\\/\\/(\w+\.)?(uploaded\.net\\/file|ul\.to(\\/file)?)\\/[0-9a-z]+\\/?(.*)?[^( |"|>|<|\r\n\|\n|$)]+?|http:\/\/(\w+\.)?cloudzer.net\/(file\/)?[0-9a-z]+\/?(.*)?|http:\/\/(\w+\.)?ryushare.com\/[0-9a-z]+?\/?[^( |"|>|<|\r\n\|\n|$)]+[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?venusfile.com\/[0-9a-z]+\/[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?dizzcloud.com\/dl\/[0-9a-z]+\/?[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?ddlstorage.com\/[0-9a-z]+\/?(.*)?[^( |"|>|<|\r\n\|\n|$)]+|http:\/\/(\w+\.)?rarefile.net\/[0-9a-z]+\/[^( |"|>|<|\r\n\|\n|$)]+|(http|https):\/\/(\w+\.)?uploadto.us\/file\/details\/[A-Za-z0-9\_\-]+\/?|(http|https):\\/\\/\w+\.?mega\.co\.nz\\/\#(F)?\!([a-zA-Z0-9]+)\!?([a-zA-Z0-9_,\-]+)?|(http|https):\/\/(\w+\.)?soundcloud.com\/([a-zA-Z0-9-_]+)\/([a-zA-Z0-9-_]+)([^( |"|>|<|\r\n\|\n|$)]+)?|(http|https):\/\/(\w+\.)?dailymotion.com\/video\/(([a-z0-9A-Z]+)|([a-z0-9]+)_([a-z0-9A-Z_-]+)[^( |"|>|<|\r\n\|\n|$)])+?|(http|https):\/\/(player\.)?(vimeo|vimeopro).com\/(?!channels\/[^\/?\#]+\/?(?:$|[?\#])|album\/)(?:.*?\/)?(?:videos?\/)?([0-9]+)([^( |"|>|<|\r\n\|\n|$)]+)?|(http|https):\/\/(\w+\.)?purevid.com\/v\/([0-9A-Za-z]+)[^( |"|>|<|\r\n\|\n|$)]+|(http|https):\/\/((\w+\.)?youtube.com\/watch\?(.*\&)?v\=[A-Za-z0-9\-\_]+|youtu.be\/[A-Za-z0-9\-\_]+)[^( |"|>|<|\r\n\|\n|$)]+|(http|https):\/\/(\w+\.)?redtube.com\/[0-9]+|(http|https):\/\/(\w+\.)?beeg.com\/([0-9]+)|(http|https):\/\/(\w+\.)?pornhub.com\\/view_video.php\?viewkey=[a-z0-9]+|(http|https):\/\/(\w+\.)?xhamster.com\/movies\/[0-9]+\/.*\.html|(http|https):\/\/(\w+\.)?youporn.com\/watch\/[0-9]+\/.*\/?|(http|https):\/\/(\w+\.)?xvideos.com\/video[0-9]+\/.*\/?|(http|https):\/\/(\w+\.)?xnxx.com\/video[0-9]+\/.*\/?|(http|https):\/\/(\w+\.)?tube8.com\/[a-z]+\/.*\/[0-9]+\/?|(http|https):\/\/(\w+\.)?porn.com\/videos\/[a-z0-9\-]+|(http|https):\/\/(\w+\.)?extmatrix.com\/files\/[a-zA-Z0-9]+\/(.*)(\.html)?\/?)';
    };

    this.reportlink = function (link, genlink, msg) {
        var notify = this.notify;
        Request({
            url: "https://linksnappy.com/api/REPORTLINKS?origlinks=" + encodeURIComponent(link) + "&genlinks=" + encodeURIComponent(genlink) + "&message=" + encodeURIComponent(msg),
            onComplete: function (response) {
                var download = JSON.parse(response.text);
                if (download.status == "OK") {
                    notify("Successfully reported " + link);
                } else {
                    notify(download.error)
                }


            }
        }).get();
    };


}

if (typeof exports !== "undefined") {
    exports.LSE = function () {
        return new LSE();
    };
}
